/****************************************
 *************   consts.h   *************
 ****************************************/

#include <exec/types.h>

/*** Constants ***/

/* Main program details */

#define VERSION_NAME		"LinkZ88 1995 Andy Dean"
#define VERSION_SHORTNAME	"LinkZ88"
#define VERSION_NUMBER		"1.0.0"
#define VERSION_DATE		"13 Mar 1995"
#define VERSION_NUMDATE		"13.03.95"

/* String lengths */

#define STRLEN_FNAME		256
#define STRLEN_ZFNAME		30
#define STRLEN_EASYREQ		1024
#define STRLEN_ERRMSG		1024
#define STRLEN_STATUS		64
#define STRLEN_ZPATH		1024

/* Misc */

#define STACKSIZE		20000

#define VERSION_OS		37

#define MAX_LISTVIEW_ENTRIES	1024

/*** Enumerated types ***/

typedef enum {
	ERROR_WARNING,
	ERROR_FATAL,
	ERROR_INTERNAL
}error_e;

typedef enum {
	ZFILETYPE_FILE,
	ZFILETYPE_DEV,
	ZFILETYPE_DIR
}zfiletype_e;
