/*****************************************
 *************   structs.h   *************
 *****************************************/

#define INTUI_V36_NAMES_ONLY

#include <exec/exec.h>			/* For the Amiga specific types */
#include <libraries/commodities.h>	/* For CxObj */
#include <intuition/intuition.h>
#include <dos/dos.h>			/* For BPTR */

struct listviewdata{
	struct Node node;

	char fname[STRLEN_ZFNAME];
	char text[STRLEN_ZFNAME];

	zfiletype_e zfiletype;
};

/*** Main project structure ***/

typedef struct project *prj_p;

struct project {
	/* Serial port stuff */

	struct MsgPort *serial_msg_port;

	struct IOExtSer *serialio;

	BOOL serial_open;

	/* Listview stuff */

	struct listviewdata *listviewarray[MAX_LISTVIEW_ENTRIES];

	struct List listviewlist;

	/* Current Z88 path */

	char zpath[STRLEN_ZPATH];

	WORD zpathdepth;

	/* Amiga path */

	char path_binary_get[STRLEN_FNAME];
	char path_binary_put[STRLEN_FNAME];

	/* Main window */

	BOOL blocked;

	struct Requester req;
};
